!=================================================
    section('data')
!=================================================

WSAData         GROUP,TYPE
wVersion            SHORT
wHighVersion        SHORT
szDescription       CSTRING(257)
szSystemStatus      CSTRING(129)
iMaxSockets         USHORT
iMaxUpdDg           USHORT
lpVendorInfo        LONG
                END
IN_ADDR         GROUP,TYPE
S_ADDR              ULONG
                END
SockAddr_In     GROUP,TYPE
SIN_FAMILY          SHORT
SIN_PORT            USHORT
SIN_ADDR            Group(IN_ADDR)
                    END
SIN_ZERO            CSTRING(8)
                END
SystemTimeType      GROUP,TYPE
wYear               USHORT
wMonth              USHORT
wDayOfWeek          USHORT
wDay                USHORT
wHour               USHORT
wMinute             USHORT
wSecond             USHORT
wMilliseconds       USHORT
                    END

PoolSize            EQUATE(65534)
POOL                cstring(PoolSize)
EType               BYTE

GetInetAddr         ulong
Email_WSAData       GROUP(WSAData)
                    END
Email_SockAddr_in   GROUP(SockAddr_In)
                    END
SystemTime          GROUP(SystemTimeType)
                    END

TmpString           &String,AUTO
EMail_PathFile      string(255)
EndOfImages         LONG

MAILFILE            FILE,DRIVER('ASCII'),PRE(MF),CREATE,BINDABLE,THREAD
Record                  RECORD,PRE()
Field                      STRING(255)
                        END
                    END

q_mailfrom  equate(2)
q_rcptto    equate(3)
q_data      equate(4)
q_date      equate(5)
q_from      equate(6)
q_org       equate(7)
q_mailer    equate(8)
q_reply     equate(9)
q_notif     equate(10)
q_to        equate(12)
q_cc        equate(13)
q_subj      equate(14)
q_begin     equate(15)

q_message   equate(99)
q_file      equate(100)

q_end       equate(100000)

!=================================================
    section('code')
!=================================================

EMail.InitMail         PROCEDURE(<BYTE ShowErr_>,<*CSTRING ErrStr_>)

EMail_AsciFile       FILE,DRIVER('ASCII'),NAME(EMail_PathFile),PRE(EAF)
Record                   RECORD,PRE()
Line                         string(250)
                         END
                     END
SavePath        string(250)
ERR             long
 code
    ERR = 0
    if Self.IsInited then return(ERR).
    if Self.QMail &=NULL
        Self.QMail &=NEW(QMailType)
    end
    free(Self.QMail)
    if Self.QSrv &=NULL
        Self.QSrv &=NEW(QMailType)
    end
    free(Self.QSrv)
    if Self.QLog &=NULL
        Self.QLog &=NEW(QLogType)
    end
    free(Self.QLog)

    if Self.QList &=NULL
        Self.QList &=NEW(QListType)
    end
    free(Self.QList)

    if Self.QCharSet &=NULL
        Self.QCharSet &=NEW(QCharSetType)
    end
    free(Self.QCharSet)

    SELF.ShowErr = ShowErr_
    if ~omitted(ErrStr_)
      SELF.ErrStr &= ErrStr_
    else
      SELF.ErrStr &= SELF.ErrStr_
      !if SELF.ShowErr=1 then SELF.ShowErr=2.
    end

    !-----
    SavePath  = Clip(Left(Command('0')))
    if SavePath[1] = '"';             SavePath = Sub(SavePath,2,Len(SavePath)-1).              !  
    if SavePath[Len(SavePath)] = '"'; SavePath = Sub(SavePath,1,Len(SavePath)-1).              !  
    loop I# = Len(SavePath) To 1 By -1                                                         !   exe-
        if SavePath[I#] = '\' or SavePath[I#] = ':'; SavePath = Sub(SavePath,1,I#); break.
    end
    EMail_PathFile = clip(SavePath) & 'CharSet.chr'

    open(EMail_AsciFile,40h)
    if errorcode()
      case SELF.ShowErr
      of 0
        message('   "CharSet.chr" ('&error()&')')
      of 1
        SELF.ErrStr = '   "CharSet.chr" ('&error()&')'
      end
      ERR = 1
      return ERR
    end
    set(EMail_AsciFile)
    loop
        next(EMail_AsciFile); if error() then break.
        len# = len(clip(EAF:LINE))
        pos# = instring('=',EAF:LINE,1,1)
        if pos# and len#
            Self.QCharSet.Code = EAF:LINE[1 : pos#-1]; Self.QCharSet.Name = clip(upper(EAF:LINE[pos#+1 : len#])); add(Self.QCharSet, +Self.QCharSet.Name)
        end
    end
    close(EMail_AsciFile)
    sort(Self.QCharSet, +Self.QCharSet.Name)

    Self.QCharSet.Name = 'DEFAULT'
    get(Self.QCharSet, Self.QCharSet.Name)
    CharCode# = Self.QCharSet.Code

    Self.QCharSet.Name = 'DEFAULTSEND'
    get(Self.QCharSet, Self.QCharSet.Name)
    CharCodeSend# = Self.QCharSet.Code

    sort(Self.QCharSet, +Self.QCharSet.Code)

    Self.QCharSet.Code = CharCode#
    get(Self.QCharSet, Self.QCharSet.Code)
    Self.CharSetDef = Self.QCharSet.Name

    Self.QCharSet.Code = CharCodeSend#
    get(Self.QCharSet, Self.QCharSet.Code)
    Self.CharSetSend = Self.QCharSet.Name

    sort(Self.QCharSet, +Self.QCharSet.Name)
    !-----

    if ~records(Self.QCharSet)
      case SELF.ShowErr
      of 0
        message('      "CharSet.chr"')
      of 1
        SELF.ErrStr = '      "CharSet.chr"'
      end
      ERR = 1
      return ERR
    end

    Self.NumLog = 0
    Self.Boundary = 'NeXtPaRtCW60EE'
    Self.Encoding = ''
    Self.IsInited = 1

 return ERR

!=================================================
EMail.KillMail         PROCEDURE
 code
    if ~Self.QMail &=NULL
        Free(Self.QMail); DISPOSE(Self.QMail)
    end
    if ~Self.QSrv &=NULL
        Free(Self.QSrv); DISPOSE(Self.QSrv)
    end
    if ~Self.QLog &=NULL
        Free(Self.QLog); DISPOSE(Self.QLog)
    end
    if ~Self.QList &=NULL
        Free(Self.QList); DISPOSE(Self.QList)
    end
    if ~Self.QCharSet &=NULL
        Free(Self.QCharSet); DISPOSE(Self.QCharSet)
    end
    if ~Self.Pool &= NULL
        Self.Pool=all('<0>',Self.PoolSize); dispose(Self.Pool)
    end
    Self.IsInited = 0
    SELF.ErrStr &= null
 return

!=================================================
Email.OpenHost         PROCEDURE(string EMail_Type,string EMail_MailHost,<short EMail_MailPort>,<string EMail_UserName>,<string EMail_Password>,<byte EMail_FlgWin>)
ERR       long
Base64Str &STRING
 code
    free(Self.QSrv); free(Self.QMail); free(Self.QLog); Self.NumLog = 0
    Self.Encoding = ''
    ERR = 0
    if ~EMail_Type
      case SELF.ShowErr
      of 0
        message('   ')
      of 1
        SELF.ErrStr = '   '
      end
      ERR = 1
      return ERR
    end
    Self.Type = clip(upper(EMail_Type))
    if ~inlist(clip(Self.Type),'SMTP','POP3')
      case SELF.ShowErr
      of 0
        message('    "'& clip(EMail_Type) &'" !')
      of 1
        SELF.ErrStr = '    "'& clip(EMail_Type) &'" !'
      end
      ERR = 1
      return ERR
    end
    if ~EMail_MailHost
      case SELF.ShowErr
      of 0
        message('  ')
      of 1
        SELF.ErrStr = '  '
      end
      ERR = 1
      return ERR
    end
    if omitted(4) or Email_MailPort=0
        case clip(Self.Type)
        of 'SMTP'; Email_MailPort = 25
        of 'POP3'; Email_MailPort = 110
        of 'IMAP4'; Email_MailPort = 143
        end
    end
    if omitted(7)
        Self.FlgProgress = 0
    else
        Self.FlgProgress = EMail_FlgWin
    end
    if Self.FlgProgress = 1
        EMail_OpenProgress()
    end

    Self.AddQSrv(Clip(Email_MailHost) & ':' & clip(left(format(Email_MailPort,@p<<<<<p))),0,0,1,'')
    case clip(Self.Type)
    of 'SMTP'
        Self.AddQSrv('EHLO LocalHost',0,1,1,'250')
        Base64Str &= Email_StringToBase64New(clip(EMail_UserName),len(clip(EMail_UserName)))
        Self.AddQSrv(Base64Str,0,2,0,'')
        clear(Base64Str)
        dispose(Base64Str)
        Base64Str &= Email_StringToBase64New(clip(EMail_Password),len(clip(EMail_Password)))
        Self.AddQSrv(Base64Str,0,3,0,'')
        clear(Base64Str)
        dispose(Base64Str)
        !Self.AddQSrv(Email_StringToBase64(EMail_UserName,len(clip(EMail_UserName))),0,2,0,'')
        !Self.AddQSrv(Email_StringToBase64(EMail_Password,len(clip(EMail_Password))),0,3,0,'')
    of 'POP3'
        Self.AddQSrv(clip(EMail_UserName),0,1,1,'')
        Self.AddQSrv(clip(EMail_Password),0,2,1,'')

        Self.AddQMail('STAT',21,0,1,'+OK')
        Self.AddQMail('LIST',21,1,1,'+OK')
        Self.AddQMail('RETR',21,2,1,'+OK')
        Self.AddQMail('DELE',21,3,1,'+OK')
        Self.AddQMail('RSET',21,5,1,'')
        Self.AddQMail('TOP',21,6,1,'+OK')

        Self.AddQMail('UIDL',31,1,1,'')
        Self.AddQMail('APOP',31,2,1,'')

    of 'IMAP4'
    end

    ERR = Self.InitSocket()
    if ERR<>0
        Self.KillSocket(); return ERR
    end
    case clip(Self.Type)
    of 'SMTP'; ERR = Self.SmtpConnect()
    of 'POP3'; ERR = Self.Pop3Connect()
    of 'IMAP4'; !ERR = Self.ConnectIMAP4()
    end

    if ERR<>0
        Self.QuitHost; return ERR
    end
 return ERR

!=================================================
Email.NoopHost         PROCEDURE
ERR     long
lRet     string(3)
 code
    Self.AddLog('NOOP')

    pool=all('<0>',poolsize)
    pool='NOOP' & '<13,10>'
    if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
        ERR=mWSAGetLastError(); return ERR
    end
    pool=all('<0>',poolsize)
    if Self.Recv(Self.E_Socket,pool,poolSize,0)<0
        ERR=mWSAGetLastError(); return ERR
    end

    case clip(Self.Type)
    of 'SMTP'; lRet = '250'
    of 'POP3'; lRet = '+OK'
    end
    if pool[1:3]<>lRet
        ERR = 1; return ERR
    end

    Self.AddLog('NOOP OK')
 return ERR

!=================================================
Email.QuitHost         PROCEDURE
ERR     long
 code
    pool=all('<0>',poolsize)
    pool='QUIT' & '<13,10>'
    if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
        ERR=mWSAGetLastError()
    end
    Self.AddLog('QUIT')
    Self.KillSocket()
 return

!=================================================
EMail.SmtpNewMail           PROCEDURE(<string EMail_CharSet>, <string EMail_Encoding>)
ERR long
 code
    ERR = 0
    !if clip(Self.Type) <> 'SMTP' then ERR = 1; message(' '); return ERR.
    if ~omitted(2)
    !    Self.CharSetSend = clip(upper(getini('CHARSET','DEFSEND','Windows-1251','.\EMAIL.INI')))
    !else
        Self.CharSetSend = clip(upper(EMail_CharSet))
    end
    if ~Self.CharSetSend then Self.CharSetSend = upper('Windows-1251').

    if ~omitted(3)
        Self.Encoding = clip(upper(EMail_Encoding))
    end
    if ~Self.Encoding then Self.Encoding = upper('8bit').

    Self.QCharSet.Name = Self.CharSetSend
    get(Self.QCharSet, Self.QCharSet.Name)
    if error()
      case SELF.ShowErr
      of 0
        message(' "'& clip(Self.CharSetSend) &'"   ')
      of 1
        SELF.ErrStr = ' "'& clip(Self.CharSetSend) &'"   '
      end
      ERR = 1
      return ERR
    end

    if ~inlist(clip(Self.Encoding),'QUOTED-PRINTABLE','BASE64','8BIT')
      case SELF.ShowErr
      of 0
        message('  "'& clip(Self.Encoding) &'"   ')
      of 1
        SELF.ErrStr = '  "'& clip(Self.Encoding) &'"   '
      end
      ERR = 1
      return ERR
    end

    if Self.FlgProgress = 1
        EMail_NewProgress(1,'    !')
    end

    Free(Self.QMail); clear(Self.QMail)
    Self.nfile = 0
    Self.AddQMail('DATA',q_data,0,1,'354')
    Self.AddQMail('DATE:',q_date,0,0,'')
 return ERR

!=================================================
Email.SmtpSetMailFrom      PROCEDURE(string EMail_FromAddress, <string EMail_FromName>)
ERR     long(0)
i       long
 code
    if len(clip(Email_FromAddress))=0
      case SELF.ShowErr
      of 0
        message('  ')
      of 1
        SELF.ErrStr = '  '
      end
      ERR = 1
      return ERR
    end
    if ~instring('@',clip(Email_FromAddress),1,1)
      case SELF.ShowErr
      of 0
        message('   ')
      of 1
        SELF.ErrStr = '   '
      end
      ERR = 1
      return ERR
    end
    Self.QMail.Position=q_mailfrom
    Self.QMail.SubPosition=0
    get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
    if ~errorcode()
        delete(Self.QMail)
        i=0
        loop
            Self.QMail.Position=q_from
            Self.QMail.SubPosition=i
            get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
            if errorcode() then break.
            delete(Self.QMail)
            i+=1
        end
    end
    Self.AddQMail('MAIL FROM:<<' & clip(Email_FromAddress) & '>',q_mailfrom,0,1,'250')
    if omitted(3)
        Self.SetQMail(,Email_FromAddress,'FROM:',q_from)
    else
        Self.SetQMail(Email_FromName,Email_FromAddress,'FROM:',q_from)
    end

 return ERR

!=================================================
Email.SmtpSetMailNotif    PROCEDURE(string EMail_FromAddress, <string EMail_FromName>)
ERR     long(0)
 code
    ERR = 0
    if len(clip(Email_FromAddress))=0
      case SELF.ShowErr
      of 0
        message('  ')
      of 1
        SELF.ErrStr = '  '
      end
      ERR = 1
      return ERR
    end
    if ~instring('@',clip(Email_FromAddress),1,1)
      case SELF.ShowErr
      of 0
        message('   ')
      of 1
        SELF.ErrStr = '   '
      end
      ERR = 1
      return ERR
    end

    if omitted(3)
        Self.SetQMail(,Email_FromAddress,'Disposition-Notification-To:',q_notif)
    else
        Self.SetQMail(Email_FromName,Email_FromAddress,'Disposition-Notification-To:',q_notif)
    end
 return ERR


!=================================================
Email.SmtpSetMailCompany  PROCEDURE(string EMail_Company)
ERR     long(0)
i       long
 code
    if len(clip(EMail_Company))=0
      case SELF.ShowErr
      of 0
        message(' ')
      of 1
        SELF.ErrStr = ' '
      end
      ERR = 1
      return
    end
    Self.SetQMail(EMail_Company,,'ORGANIZATION:',q_org)
 return

!=================================================
Email.SmtpSetMailXMailer      PROCEDURE(string EMail_XMailer)
ERR     long(0)
i       long
 code
    if len(clip(EMail_XMailer))=0
      case SELF.ShowErr
      of 0
        message(' X-Mailer')
      of 1
        SELF.ErrStr = ' X-Mailer'
      end
      ERR = 1
      return 
    end
    Self.SetQMail(EMail_XMailer,,'X-MAILER:',q_mailer)
 return

!=================================================
Email.SmtpSetMailReply      PROCEDURE(string EMail_FromAddress, <string EMail_FromName>)
ERR     long(0)
i       long
 code
    if len(clip(Email_FromAddress))=0
      case SELF.ShowErr
      of 0
        message('  ')
      of 1
        SELF.ErrStr = '  '
      end
      ERR = 1
      return ERR
    end
    if ~instring('@',clip(Email_FromAddress),1,1)
      case SELF.ShowErr
      of 0
        message('   ')
      of 1
        SELF.ErrStr = '   '
      end
      ERR = 1
      return ERR
    end
    if omitted(3)
        Self.SetQMail(,Email_FromAddress,'REPLY-TO:',q_reply)
    else
        Self.SetQMail(Email_FromName,Email_FromAddress,'REPLY-TO:',q_reply)
    end
 return ERR

!=================================================
EMail.SmtpAddMailRcptTo    PROCEDURE(string EMail_RCPTAddress, <string EMail_RCPTName>)
ERR     long(0)
lenA    long
l       long
i       long
subpos  long
pos     long
Adres   string(100)
st      long
 code
    if len(clip(EMail_RCPTAddress))=0
      case SELF.ShowErr
      of 0
        message('  ')
      of 1
        SELF.ErrStr = '  '
      end
      ERR = 1
      return ERR
    end
    if ~instring('@',clip(EMail_RCPTAddress),1,1)
      case SELF.ShowErr
      of 0
        message('   ')
      of 1
        SELF.ErrStr = '   '
      end
      ERR = 1
      return ERR
    end

    l=len(clip(EMail_RCPTAddress))
    TmpString &= NEW(STRING(l*3))
    clear(TmpString)

    st = 1
    lenA = len(clip(EMail_RCPTAddress))
    subpos = 0
    loop i = 1 to lenA
        pos = inlist(EMail_RCPTAddress[i],',',';',' ','<','>')
        if pos
            if i = lenA
                Adres = EMail_RCPTAddress[st : i-1]
                Self.AddQMail('RCPT TO:<<' & clip(Adres) & '>',q_rcptto,subpos,1,'250')
                TmpString = clip(Adres)
                if subpos = 0
                    if omitted(3)
                        Self.SetQMail(,clip(TmpString),'To:',q_to)
                    else
                        Self.SetQMail(EMail_RCPTName,clip(TmpString),'To:',q_to)
                    end
                else
                    Self.SetQMail('.',clip(TmpString),'To:',q_to)
                end
                subpos += 1
            else
                if i <> st
                    Adres = EMail_RCPTAddress[st : i-1]
                    Self.AddQMail('RCPT TO:<<' & clip(Adres) & '>',q_rcptto,subpos,1,'250')
                    TmpString = clip(Adres)
                    if subpos = 0
                        if omitted(3)
                            Self.SetQMail(,clip(TmpString),'To:',q_to)
                        else
                            Self.SetQMail(EMail_RCPTName,clip(TmpString),'To:',q_to)
                        end
                    else
                        Self.SetQMail('.',clip(TmpString),'To:',q_to)
                    end
                    subpos += 1
                end
                st = i+1
            end
        else
            if i = lenA
                Adres = EMail_RCPTAddress[st : i]
                Self.AddQMail('RCPT TO:<<' & clip(Adres) & '>',q_rcptto,subpos,1,'250')
                TmpString = clip(Adres)
                if subpos = 0
                    if omitted(3)
                        Self.SetQMail(,clip(TmpString),'To:',q_to)
                    else
                        Self.SetQMail(EMail_RCPTName,clip(TmpString),'To:',q_to)
                    end
                else
                    Self.SetQMail('.',clip(TmpString),'To:',q_to)
                end
                subpos += 1
            end
        end
    end
    clear(TmpString); dispose(TmpString)
 return ERR

!=================================================
EMail.SmtpAddMailRcptCC    PROCEDURE(string EMail_RCPTAddress, <string EMail_RCPTName>)
ERR     long(0)
lenA    long
l       long
i       long
subpos  long
pos     long
Adres   string(100)
st      long
 code
    if len(clip(EMail_RCPTAddress))=0
      case SELF.ShowErr
      of 0
        message('   ')
      of 1
        SELF.ErrStr = '   '
      end
      ERR = 1
      return ERR
    end
    if ~instring('@',clip(EMail_RCPTAddress),1,1)
      case SELF.ShowErr
      of 0
        message('    ')
      of 1
        SELF.ErrStr = '    '
      end
      ERR = 1
      return ERR
    end

    l=len(clip(EMail_RCPTAddress))
    TmpString &= NEW(STRING(l*3))
    clear(TmpString)

    st = 1
    lenA = len(clip(EMail_RCPTAddress))
    subpos = 0
    loop i = 1 to lenA
        pos = inlist(EMail_RCPTAddress[i],',',';',' ','<','>')
        if pos
            if i = lenA
                Adres = EMail_RCPTAddress[st : i-1]
                TmpString = clip(Adres)
                if subpos = 0
                    if omitted(3)
                        Self.SetQMail(,clip(TmpString),'CC:',q_cc)
                    else
                        Self.SetQMail(EMail_RCPTName,clip(TmpString),':',q_cc)
                    end
                else
                    Self.SetQMail('.',clip(TmpString),':',q_cc)
                end
                subpos += 1
            else
                if i <> st
                    Adres = EMail_RCPTAddress[st : i-1]
                    TmpString = clip(Adres)
                    if subpos = 0
                        if omitted(3)
                            Self.SetQMail(,clip(TmpString),':',q_cc)
                        else
                            Self.SetQMail(EMail_RCPTName,clip(TmpString),':',q_cc)
                        end
                    else
                        Self.SetQMail('.',clip(TmpString),':',q_cc)
                    end
                    subpos += 1
                end
                st = i+1
            end
        else
            if i = lenA
                Adres = EMail_RCPTAddress[st : i]
                TmpString = clip(Adres)
                if subpos = 0
                    if omitted(3)
                        Self.SetQMail(,clip(TmpString),':',q_cc)
                    else
                        Self.SetQMail(EMail_RCPTName,clip(TmpString),':',q_cc)
                    end
                else
                    Self.SetQMail('.',clip(TmpString),':',q_cc)
                end
                subpos += 1
            end
        end
    end
    clear(TmpString); dispose(TmpString)
 return ERR

!=================================================
Email.SmtpSetMailSubject      PROCEDURE(string EMail_Subject)
i   long
 code
    Self.QMail.Position=q_subj
    Self.QMail.SubPosition=0
    get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
    if ~errorcode()
        delete(Self.QMail)
        i=1
        loop
            Self.QMail.Position=q_subj
            Self.QMail.SubPosition=i
            get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
            if errorcode() then break.
            delete(Self.QMail)
            i+=1
        end
    end
    Self.SetQMail(EMail_Subject,,'Subject:',q_subj)
 return

!=================================================
Email.SmtpAddMailMessage       PROCEDURE(string EMail_Message, <byte MailType>)
in_      long
l       long
ls      long
is      long
i       long
tmpstr  string(80)

Base64Str &STRING
 code
    Self.QMail.Position=q_begin
    Self.QMail.SubPosition=2
    get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
    if errorcode()
        Self.AddQMail('MIME-Version: 1.0',q_begin,0,0,'')
        if MailType<2
          Self.AddQMail('Content-Type: multipart/mixed;',q_begin,1,0,'')
          Self.AddQMail(' boundary="'& clip(Self.Boundary) &'_MIX"',q_begin,2,0,'')
          if MailType
            Self.AddQMail('',q_begin,3,0,'')
            Self.AddQMail('<13,10>--' & clip(Self.Boundary) & '_MIX',q_begin,4,0,'')
            Self.AddQMail('Content-Type: multipart/related;',q_begin,5,0,'')
            Self.AddQMail(' boundary="'& clip(Self.Boundary) &'_REL"',q_begin,6,0,'')
            Self.AddQMail('',q_begin,7,0,'')
            Self.AddQMail('<13,10>--' & clip(Self.Boundary) & '_REL',q_begin,8,0,'')
            Self.AddQMail('Content-Type: multipart/alternative;',q_begin,9,0,'')
            Self.AddQMail(' boundary="'& clip(Self.Boundary) &'_ALT"',q_begin,10,0,'')
            EndOfImages=1
          end
        end
    end
    in_=0
    Self.QMail.Position=q_message
    loop
        Self.QMail.Subposition=in_
        get(Self.QMail,Self.QMail.Position,Self.QMail.Subposition)
        if errorcode() then break.
        in_+=1
    end
    case MailType
    of 0
      Self.AddQMail('',q_message,in_,0,'')
      Self.AddQMail('<13,10>--' & clip(Self.Boundary) & '_MIX',q_message,in_+1,0,'')
    of 1
      Self.AddQMail('',q_message,in_,0,'')
      Self.AddQMail('<13,10>--' & clip(Self.Boundary) & '_ALT',q_message,in_+1,0,'')
    of 2
    end
    Self.AddQMail('Content-Type: text/plain;',q_message,in_+2,0,'')
    Self.AddQMail('         charset="'& clip(Self.CharSetSend) &'"',q_message,in_+3,0,'')
    Self.AddQMail('Content-Transfer-Encoding: '& clip(Self.Encoding),q_message,in_+4,0,'')
    Self.AddQMail('',q_message,in_+5,0,'')
    l=len(clip(EMail_Message))
    TmpString &= NEW(STRING(l*3))
    clear(TmpString)

    Self.QMail.Wait=0
    Self.QMail.What=''
    Self.QMail.Position=q_message
    Self.QMail.SubPosition=in_+6
    clear(Self.QMail.Line)
    case clip(Self.Encoding)
    of 'QUOTED-PRINTABLE'
        TmpString=Email_StringToQuoted(Self.ConvertCharSet(Clip(EMail_Message),Self.CharSetDef,Self.CharSetSend),l)

        ls=len(clip(TmpString))
        is=0
        loop i=1 to ls
            is+=1
            Self.QMail.Line = clip(Self.QMail.Line) & TmpString[i]
            if is>70
                if (Self.QMail.Line[is-1] = '=') or (Self.QMail.Line[is] = '=')
                    cycle
                else
                    is=0
                    Self.QMail.Line=clip(Self.QMail.Line) & '='
                    Self.AddQMail()
                    Self.QMail.SubPosition += 1
                    !Self.AddLog(clip(Self.QMail.Line))
                    clear(Self.QMail.Line)
                end
            end
        end
        Self.AddQMail()

    of 'BASE64'

        !TmpString=Email_StringToBase64(Self.ConvertCharSet(Clip(EMail_Message),Self.CharSetDef,Self.CharSetSend),l)
        Base64Str &= Email_StringToBase64New(Self.ConvertCharSet(Clip(EMail_Message),Self.CharSetDef,Self.CharSetSend),l)

        Self.AddQSrv(Base64Str,0,3,0,'')

        ls=len(clip(Base64Str))
        is=0
        loop i=1 to ls
            is+=1
            Self.QMail.Line = clip(Self.QMail.Line) & Base64Str[i]
            if is>70
                is=0
                Self.QMail.Line=clip(Self.QMail.Line)
                Self.AddQMail()
                Self.QMail.SubPosition += 1
                !Self.AddLog(clip(Self.QMail.Line))
                clear(Self.QMail.Line)
            end
        end
        Self.AddQMail()
        clear(Base64Str)
        dispose(Base64Str)

    of '8BIT'

        TmpString=Self.ConvertCharSet(Clip(EMail_Message),Self.CharSetDef,Self.CharSetSend)
        ls=len(clip(TmpString))
        is=1
        loop i=1 to ls
          if TmpString[i : i+1] = '<13,10>'
            Self.QMail.Line=TmpString[is : i-1]
            Self.AddQMail()
            Self.QMail.SubPosition += 1
            is=i+2
          elsif i-is+1>63900
            Self.QMail.Line=TmpString[is : i-1]
            Self.AddQMail()
            Self.QMail.SubPosition += 1
            is=i+1
          end
        end
        Self.QMail.Line=TmpString[is : i-1]
        Self.AddQMail()

    end

    clear(TmpString); dispose(TmpString)
 return

!=================================================
EMail.SmtpAddMailHTML   PROCEDURE(string EMail_HTML)
i_ long
i  long
l  long
ls long
is long
ERR long
 code
    ERR = 0
    i_=0
    Self.QMail.Position=q_message
    loop
        Self.QMail.Subposition=i_
        get(Self.QMail,Self.QMail.Position,Self.QMail.Subposition)
        if errorcode() then break.
        i_+=1
    end
    Self.AddQMail('',q_message,i_,0,'')
    Self.AddQMail('<13,10>--' & clip(Self.Boundary) & '_ALT',q_message,i_+1,0,'')
    Self.AddQMail('Content-Type: text/html;',q_message,i_+2,0,'')
    Self.AddQMail('         charset="'& clip(Self.CharSetSend) &'"',q_message,i_+3,0,'')
    Self.AddQMail('Content-Transfer-Encoding:  quoted-printable',q_message,i_+4,0,'')
    Self.AddQMail('',q_message,i_+5,0,'')

    l=len(clip(EMail_HTML))
    TmpString &= NEW(STRING(l*3))
    clear(TmpString)

    Self.QMail.Wait=0
    Self.QMail.What=''
    Self.QMail.Position=q_message
    Self.QMail.SubPosition=i_+6
    clear(Self.QMail.Line)

    TmpString=Email_StringToQuoted(Self.ConvertCharSet(Clip(EMail_HTML),Self.CharSetDef,Self.CharSetSend),l)

    ls=len(clip(TmpString))
    is=0
    loop i=1 to ls
        is+=1
        Self.QMail.Line = clip(Self.QMail.Line) & TmpString[i]
        if is>70
            if (Self.QMail.Line[is-1] = '=') or (Self.QMail.Line[is] = '=')
                cycle
            else
                is=0
                Self.QMail.Line=clip(Self.QMail.Line) & '='
                Self.AddQMail()
                Self.QMail.SubPosition += 1
                clear(Self.QMail.Line)
            end
        end
    end
    Self.AddQMail()

    Self.QMail.SubPosition += 1
    Self.QMail.Line='<13,10>--'& clip(Self.Boundary) &'_ALT--'
    Self.AddQMail()

    clear(TmpString); dispose(TmpString)

 return

!=================================================
EMail.SmtpAddMailFile   PROCEDURE(string EMail_File, <string EMail_ContentID>, <string EMail_Name>)
ni  long
i   long
ERR long
e_name cstring(256)
tmpstr  string(400)
Base64Str &STRING
 code
    ERR = 0
    if clip(EMail_File)='' then return ERR.

    !  multipart/related
    if clip(EMail_ContentID)='' and EndOfImages
      if EndOfImages<q_message then EndOfImages=q_message.
      Self.QMail.Position=EndOfImages+1
      Self.QMail.SubPosition=0
      get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
      if errorcode()
        Self.AddQMail('<13,10>--'& clip(Self.Boundary) &'_REL--',EndOfImages+1,0,0,'')
        Self.nfile + =1
      end
      EndOfImages=0
    end

    Self.nfile + =1
    ni=0
    loop i=len(clip(EMail_File)) to 1 by -1
        if EMail_File[i]='/' or EMail_File[i]='\' or EMail_File[i]=':' then break.
    end
    ni = i
    if clip(EMail_Name)=''
      e_name=sub(EMail_File,ni+1,len(clip(EMail_File))-ni)
    else
      e_name=clip(EMail_Name)
    end

    case clip(Self.Encoding)
    of 'QUOTED-PRINTABLE'
        tmpstr = '=?'& clip(Self.CharSetSend) &'?Q?'& |
        clip(EMail_StringToQuoted(clip(Self.ConvertCharSet(clip(e_name),Self.CharSetDef,Self.CharSetSend)),len(clip(e_name)))) & '?='

    else
        tmpstr = '=?'& clip(Self.CharSetSend) &'?B?'
        Base64Str &= Email_StringToBase64New(clip(Self.ConvertCharSet(clip(e_name),Self.CharSetDef,Self.CharSetSend)),len(clip(e_name)))
        tmpstr = clip(tmpstr) & Base64Str & '?='
        clear(Base64Str)
        dispose(Base64Str)
    end

    if clip(EMail_ContentID)=''
      Self.AddQMail('<13,10>--'& clip(Self.Boundary)&'_MIX',q_file+Self.nfile,0,0,'')
      Self.AddQMail(' name="' & clip(tmpstr) &'"',q_file+Self.nfile,2,0,'')
      Self.AddQMail('Content-Disposition: attachment;',q_file+Self.nfile,5,0,'')
      Self.AddQMail(' filename="' & clip(tmpstr) &'"',q_file+Self.nfile,6,0,'')
    else
      Self.AddQMail('<13,10>--'& clip(Self.Boundary)&'_REL',q_file+Self.nfile,0,0,'')
      Self.AddQMail(' name="' & clip(tmpstr) &'"',q_file+Self.nfile,2,0,'')
      Self.AddQMail('Content-ID: <'&clip(EMail_ContentID)&'>',q_file+Self.nfile,5,0,'')
      EndOfImages=q_file+Self.nfile
    end
    Self.AddQMail('',q_file+Self.nfile,6,0,'')
    case upper(sub(EMail_File,len(clip(EMail_File))-2,3))
    of 'GIF'
        Self.AddQMail('Content-Type: image/gif;',q_file+Self.nfile,1,0,'')
        Self.AddQMail('Content-Transfer-Encoding: base64',q_file+Self.nfile,4,0,'')
        ERR = Self.FileToBase64(EMail_File,q_file+Self.NFile)
    of 'JPG'
        Self.AddQMail('Content-Type: image/jpg;',q_file+Self.nfile,1,0,'')
        Self.AddQMail('Content-Transfer-Encoding: base64',q_file+Self.nfile,4,0,'')
        ERR = Self.FileToBase64(EMail_File,q_file+Self.NFile)
    of 'TXT'
        Self.AddQMail('Content-Type: text/plain;',q_file+Self.nfile,1,0,'')
        Self.AddQMail('Content-Transfer-Encoding: quoted-printable',q_file+Self.nfile,4,0,'')
        ERR = Self.FileToQuoted(EMail_File,q_file+Self.NFile)
    else
        Self.AddQMail('Content-Type: application/octet-stream;',q_file+Self.nfile,1,0,'')
        Self.AddQMail('Content-Transfer-Encoding: base64',q_file+Self.nfile,4,0,'')
        ERR = Self.FileToBase64(EMail_File,q_file+Self.NFile)
    end
 return ERR

!=================================================
Email.SmtpSendMail         PROCEDURE
i       long
ERR     long(0)
ewait   long
eWhat   string(32)
 code
    if EndOfImages
      if EndOfImages<q_message then EndOfImages=q_message.
      Self.QMail.Position=EndOfImages+1
      Self.QMail.SubPosition=0
      get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
      if errorcode()
        Self.AddQMail('<13,10>--'& clip(Self.Boundary) &'_REL--',EndOfImages+1,0,0,'')
        Self.nfile + =1
      end
    end
    Self.QMail.Position=q_begin
    Self.QMail.SubPosition=2
    get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
    if ~errorcode()
        Self.AddQMail('<13,10>--'& clip(Self.Boundary) &'_MIX--',q_end,0,0,'')
    end
    Self.AddQMail('',q_end,1,0,'')
    Self.AddQMail('<13,10><13,10>.',q_end,2,1,'250')
    Self.SetQMailDate()
    if Self.FlgProgress = 1
        EMail_NextProgress()
        rec# = records(Self.QMail)
        EMail_NewProgress(rec#,'  !')
    end
    Self.AddLog(' ')
    loop i=1 to records(Self.QMail)
        get(Self.QMail,i); if error() then break.

        if Self.FlgProgress = 1
            EMail_NextProgress()
        end

        pool=all('<0>',poolsize)
        pool=clip(Self.QMail.Line) & '<13,10>'
        ewait=Self.QMail.Wait
        eWhat=Self.QMail.What
        Self.AddLog(clip(pool))
        if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
            ERR=mWSAGetLastError(); break
        end
        if ewait
            pool=all('<0>',poolsize)
            if Self.Recv(Self.E_Socket,pool,poolSize,0)<0
                ERR=mWSAGetLastError(); break
            end
            Self.AddLog(clip(pool))
            if pool[1:3]<>clip(EWhat)
                ERR = pool[1:3]
                if ERR = 550    !     ,     ( )
                  case SELF.ShowErr
                  of 0
                    message(': ' & pool & '           !','!',icon:asterisk)
                  of 1
                    SELF.ErrStr = ': ' & pool & '           !'
                  end
                end
                break
            end
        end
    end
    if ERR <> 0
        Self.AddLog(' ERR = '& ERR)
        case SELF.ShowErr
        of 1
          SELF.ErrStr = ': '& ERR
        end
    else
        Self.AddLog(' OK')
    end
 return ERR

!=================================================
Email.Pop3ListMail         PROCEDURE(*long EMail_Count)
ERR     long
eWait   long
eWhat   string(32)
i       long
pos     long
pos2    long
 code
    ERR = 0
    EMail_Count = 0
    free(Self.QList)

    Self.AddLog('   ')

    !-----------------------------
    Self.QMail.Position=21
    Self.QMail.SubPosition=0
    get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
    if errorcode()
        ERR = 1; message('   STAT  OpenHost() !','!',icon:asterisk); return ERR
    end
    pool=all('<0>',poolsize)
    pool=clip(Self.QMail.Line) & '<13,10>'
    eWait=Self.QMail.Wait
    eWhat=Self.QMail.What
    Self.AddLog(clip(pool))
    if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
        ERR = mWSAGetLastError(); return ERR
    end
    if eWait
        pool=all('<0>',poolsize)
        if Self.Recv(Self.E_Socket,pool,poolSize,0)<0
            ERR=mWSAGetLastError(); return ERR
        end
        Self.AddLog(clip(pool))
        if pool[1:3]<>clip(EWhat)
            ERR = 1; return ERR
        end
    end
    end# = instring(' ',pool,1,5)
    Count" = pool[4 : end#-1]
    EMail_Count = Count"
    !-----------------------------
    Self.QMail.Position=21
    Self.QMail.SubPosition=1
    get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
    if errorcode()
        ERR = 1; message('   LIST  OpenHost() !','!',icon:asterisk); return ERR
    end
    pool=all('<0>',poolsize)
    pool=clip(Self.QMail.Line) & '<13,10>'
    eWait=Self.QMail.Wait
    eWhat=Self.QMail.What
    Self.AddLog(clip(pool))
    if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
        ERR = mWSAGetLastError(); return ERR
    end
    if eWait
        pool=all('<0>',poolsize)
        if Self.Recv(Self.E_Socket,pool,poolSize,0,1)<0
            ERR=mWSAGetLastError(); return ERR
        end
        Self.AddLog(clip(pool))
        if pool[1:3]<>clip(EWhat)
            ERR = 1; return ERR
        end
    end
    i = 0
    loop
        i += 1
        stri" = i
        pos = instring('<13,10>'& clip(stri") &' ',pool,1,1)
        if pos
            pos2 = instring('<13,10>',pool,1,pos+2)
            if pos2
                Self.QList.Num = i
                Self.QList.Size = pool[pos+2+len(clip(stri"))+1 : pos2-1]
                add(Self.QList,+Self.QList.Num)
            end
        else
            break
        end
    end
    !message(pool)
    !message(records(Self.QList))
    !-----------------------------
    Self.AddLog('    OK')
 return ERR

EMail.OpenMail  PROCEDURE(string Email_File, byte Email_Type, <string EMail_Path>)
ERR         long

 code

  if ~omitted(2)
      Self.PathFile = EMail_Path
  end

  if Self.PathFile
      if Self.PathFile[len(clip(Self.PathFile))] <> '\' then Self.PathFile = clip(Self.PathFile) &'\'.
  else
      Self.PathFile = '.\'
  end

  self.EType = Email_type

  MAILFILE{prop:name}=Email_File
  case self.EType
  of 2
    SEND(MAILFILE,'ENDOFRECORD=2,13,10')      ! Message
  of 1
    SEND(MAILFILE,'ENDOFRECORD=1,10')         ! Unix box
  end
  open(MAILFILE)

  return ERR

EMail.CloseMail      PROCEDURE
ERR         long
 code
  close(MAILFILE)
  return ERR

EMail.ReadMail       PROCEDURE(*string EMail_Pos, <long EMail_Total>, <*long EMail_Size>)
pos         long
pos2        long
l           long
i           long
ERR         long
lTop         long

FQ          queue
Field         cstring(256)
Size          long
            end
 code
    if ~omitted(3)
        lTop = EMail_Total
        if lTop < 0 then lTop = 0.
    else
        lTop = -1
    end
    free(FQ)
    clear(FQ)
    flag#=0
    poolsize#=0
    if ~omitted(4)
      EMail_Size=0
    end
    if clip(EMail_Pos)<>''
      reset(MAILFILE,EMail_Pos)
    else
      set(MAILFILE)
    end
    if self.EType=1
      next(MAILFILE)
    end
    loop
      next(MAILFILE)
      if errorcode()
        EMail_Pos=''
        break
      end
      FQ.Size=len(clip(MF:FIELD))
      if ~omitted(4)
        EMail_Size+=FQ.Size+2
      end
      if MF:FIELD[1 : 5]='From '
        EMail_Pos=position(MAILFILE)
        break
      end
      if flag#=0
        FQ.Field=clip(MF:FIELD)
        poolsize#+=FQ.Size+2
        add(FQ)
      end
      if FQ.Size=0 and lTop=0 then flag#=1.
    end

    Self.PoolSize=poolsize#+3
    Self.Pool &= NEW(CSTRING(Self.PoolSize))
    l=0
    loop i#=1 to records(FQ)
      get(FQ,i#)
      Self.pool[l+1 : l+FQ:Size+2]=clip(FQ:FIELD)&'<13><10>'
      l+=FQ:Size+2
    end
    Self.pool[l+1 : l+2]='<46><13>'
    self.nFile=1
    ! ==========   ==========
    pos = 0; pos2 = 0
    clear(Self.Boundary)
    pos = instring('BOUNDARY=',upper(Self.pool),1,1)
    if pos
        pos += 9
        if Self.pool[pos]='"' then pos+=1.
        loop i = pos to l
            if Self.pool[i] = '"' or val(Self.pool[i])=13
                pos2 = i-1; break
            end
        end
        if pos2
            Self.Boundary = Self.pool[pos : pos2]
        end
    end
    if EMail_Pos='' then return 1.

 return ERR
!=================================================
EMail.Pop3ReadMail       PROCEDURE(long Email_Num, <string EMail_Path>, <long EMail_Total>, <*long EMail_Size>)
lTop         long
ERR         long
eWait       long
eWhat       string(32)
pos         long
pos2        long
lCharSet    string(32)
l           long
i           long
flg         byte
 code
    Self.nFile = 1
    Self.PathFile = ''
    ERR = 0
    if ~records(Self.QList) then message('  0 !  .'); return ERR.

    if ~omitted(3)
        Self.PathFile = EMail_Path
    end
    if ~omitted(4)
        lTop = EMail_Total
        if lTop < 0 then lTop = 0.
    else
        lTop = -1
    end
    if Self.PathFile
        if Self.PathFile[len(clip(Self.PathFile))] <> '\' then Self.PathFile = clip(Self.PathFile) &'\'.
    else
        Self.PathFile = '.\'
    end

    Self.QList.Num = EMail_Num
    get(Self.QList,Self.QList.Num)
    if error() then message('      '& EMail_Num &'!'); return ERR.

    if Self.FlgProgress = 1
        EMail_NewProgress(10,'   '& EMail_Num &' !')
    end

    if ~omitted(5)
        EMail_Size = Self.QList.Size
    end

    if ~Self.Pool &= NULL
        Self.Pool=all('<0>',Self.PoolSize); dispose(Self.Pool)
    end

    Self.PoolSize = Self.QList.Size + (1/4*Self.QList.Size)

    Self.Pool &= NEW(CSTRING(Self.PoolSize))
    Self.Pool=all('<0>',Self.PoolSize)

    Self.AddLog('   '& EMail_Num)

    pool=all('<0>',poolsize)

    if lTop = -1
        Self.QMail.Position=21
        Self.QMail.SubPosition=2
        get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
        if errorcode()
            ERR = 1; message('   RETR  OpenHost() !','!',icon:asterisk); return ERR
        end
        pool=clip(Self.QMail.Line) &' '& EMail_Num &'<13,10>'
    else
        Self.QMail.Position=21
        Self.QMail.SubPosition=6
        get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
        if errorcode()
            ERR = 1; message('   TOP  OpenHost() !','!',icon:asterisk); return ERR
        end
        pool=clip(Self.QMail.Line) &' '& EMail_Num &' '& lTop &'<13,10>'
    end

    eWait=Self.QMail.Wait
    eWhat=Self.QMail.What
    Self.AddLog(clip(pool))
    if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
        ERR = mWSAGetLastError(); return ERR
    end
    if Self.FlgProgress = 1
        EMail_NextProgress('...')
    end
    if ewait
        if Self.Recv(Self.E_Socket,Self.pool,Self.poolSize,0,1,1)<0
            ERR=mWSAGetLastError(); return ERR
        end
        Self.AddLog(clip(Self.pool))
        if Self.pool[1:3]<>clip(EWhat)
            ERR = 1; return ERR
        end
    end
    l = len(clip(Self.pool))
    ! ==========   ==========
    clear(Self.Boundary); pos = 0; pos2 = 0
    pos = instring('BOUNDARY=',upper(Self.pool),1,1)
    if pos
        pos += 9
        if Self.pool[pos]='"' then pos+=1.
        loop i = pos to l
            if Self.pool[i] = '"' or val(Self.pool[i])=13
                pos2 = i-1; break
            end
        end
        if pos2
            Self.Boundary = Self.pool[pos : pos2]
        end
    end
    Self.AddLog('   '& EMail_Num &' OK')

 return ERR

EMail.Pop3DelMail       PROCEDURE(long EMail_Num)
ERR         long
eWait       long
eWhat       string(32)
l           long
 code
    ERR = 0
    if ~records(Self.QList) then message('  0 !  .'); return ERR.

    Self.QList.Num = EMail_Num
    get(Self.QList,Self.QList.Num)
    if error() then message('      '& EMail_Num &'!'); return ERR.

    Self.AddLog('   '& EMail_Num)

    if Self.FlgProgress = 1
        EMail_NextProgress('  ...')
    end

    Self.QMail.Position=21
    Self.QMail.SubPosition=3
    get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
    if errorcode()
        ERR = 1; message('   DELE  OpenHost() !','!',icon:asterisk); return ERR
    end
    pool=all('<0>',poolsize)
    pool=clip(Self.QMail.Line) &' '& EMail_Num &'<13,10>'
    eWait=Self.QMail.Wait
    eWhat=Self.QMail.What
    Self.AddLog(clip(pool))

    if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
        ERR = mWSAGetLastError(); return ERR
    end

    if ewait
        pool=all('<0>',poolsize)
        if Self.Recv(Self.E_Socket,pool,poolSize,0)<0
            ERR=mWSAGetLastError(); return ERR
        end

        Self.AddLog(clip(pool))
        if pool[1:3]<>clip(EWhat)
            ERR = 1; return ERR
        end
    end
    Self.AddLog('   '& EMail_Num &' OK')
 return ERR

EMail.Pop3GetMailDate     PROCEDURE(*long EMail_Date, *long EMail_Time)
pos     long
pos2    long
i       long
l       long
m       long
 code
    EMail_Date = 0; pos = 0; pos2 = 0
    l = len(clip(Self.pool))
    pos = instring('<13,10>DATE: ',upper(self.pool),1,1)
    if pos=0 and upper(self.pool[1 : 6])='DATE: ' then pos=1.
    if pos
        loop i = pos to l
            pos2 = instring(self.pool[i],'0123456789',1,1)
            if pos2 then break.
        end
        if pos2
          p#=1
          if self.pool[i+1]=' ' then p#=0.
          case upper(self.pool[i+2+p# : i+4+p#])
          of 'JAN'
            m=1
          of 'FEB'
            m=2
          of 'MAR'
            m=3
          of 'APR'
            m=4
          of 'MAY'
            m=5
          of 'JUN'
            m=6
          of 'JUL'
            m=7
          of 'AUG'
            m=8
          of 'SEP'
            m=9
          of 'OCT'
            m=10
          of 'NOV'
            m=11
          of 'DEC'
            m=12
          end
          EMail_Date = date(m,self.pool[i : i+p#],self.pool[i+6+p# : i+9+p#])
          Email_Time = deformat(self.pool[i+11+p# : i+19+p#],@T4)
        end
    end
 return

EMail.Pop3GetMailId     PROCEDURE(*string EMail_ID)
 code
    EMail_ID = ''; Self.FindString('<13,10>MESSAGE-ID: ', EMail_ID)
    pos# = instring('<',EMail_ID,1,1)
    pos2# = instring('>',EMail_ID,1,1)
    EMail_ID = EMail_ID[pos#+1 : pos2#-1]
 return

EMail.Pop3GetMailFrom     PROCEDURE(*? EMail_FromName)
 code
    EMail_FromName = ''; Self.FindString('<13,10>FROM: ', EMail_FromName)
 return

EMail.Pop3GetMailXMailer  PROCEDURE(*? EMail_XMailer)
 code
    EMail_XMailer = ''; Self.FindString('<13,10>X-MAILER: ', EMail_XMailer)
 return

EMail.Pop3GetMailCompany  PROCEDURE(*? EMail_Company)
 code
    EMail_Company = ''; Self.FindString('<13,10>ORGANIZATION: ', EMail_Company)
 return

EMail.Pop3GetMailReply    PROCEDURE(*? EMail_FromName)
 code
    EMail_FromName = ''; Self.FindString('<13,10>REPLY-TO: ', EMail_FromName)
 return

EMail.Pop3GetMailTo       PROCEDURE(*? EMail_ToName)
 code
    EMail_ToName = ''; Self.FindString('<13,10>TO: ', EMail_ToName)
 return

EMail.Pop3GetMailCC       PROCEDURE(*? EMail_ToName)
 code
    EMail_ToName = ''; Self.FindString('<13,10>CC: ', EMail_ToName)
 return

EMail.Pop3GetMailSubject  PROCEDURE(*? EMail_Subject)
 code
    EMail_Subject = ''; Self.FindString('<13,10>SUBJECT: ', EMail_Subject)
 return

EMail.Pop3GetMailMessage  PROCEDURE(*? EMail_Message, *byte EMail_FlgFile, *string EMail_ContType)
ERR long
flg byte
RETSTR  string(3)
 code
    ERR = 0; flg = 0

    EMail_Message = ''
    if Self.FlgProgress = 1
        EMail_NextProgress('...')
    end
    if Self.Boundary
       RetStr = Self.FindText('<13,10>--'& clip(Self.Boundary), EMail_Message, Self.nFile, flg, EMail_ContType)
    else
       RetStr = Self.FindText(clip(Self.Boundary), EMail_Message, Self.nFile, flg, EMail_ContType)
    end
    EMail_FlgFile = flg
    if upper(RetStr) = 'ERR'
        ERR = 1; EMail_Message = ''; return ERR
    end

 return ERR

!=================================================
!=================================================
!=================================================
!=================================================
!=================================================
EMail.Recv       PROCEDURE(UnSigned E_Socket_,*cString pool_,Signed poolsize_,Signed loc_,<byte flgmany_>,<byte pooltype_>)
lPool       &CSTRING,AUTO
ret         signed
pos         long
flg         byte
l           long
flgmany     byte
i           long
apool       &CSTRING
apoolsize   long
spool       &CSTRING
spoolsize   long
!time1       long
 CODE
    apoolsize=poolsize_
    aPool &= NEW(CSTRING(apoolsize))
    aPool=all('<0>',apoolsize)

    lPool &= NEW(CSTRING(poolsize))
    lPool=all('<0>',poolsize)

    ret = -1; flg = FALSE
    pool_=all('<0>',poolsize_)
    case clip(Self.Type)
    of 'SMTP'
        loop
            lPool=all('<0>',poolsize_)
            ret = mRecv(E_Socket_,lPool,poolSize_,loc_); if ret < 0 then break.
            !message(E_Socket_ &'='& poolsize_ &'='&lpool)
            pool_ = pool_ & lPool
            !if lPool[4] = ' ' then break.
            pos = 0; flg = FALSE
            loop
                pos += 1
                pos = instring('<13,10>',Pool_,1,pos); if pos = 0 then flg = TRUE; break.
                if Pool_[pos+5] = ' '
                    flg = TRUE; break
                elsif Pool_[4] = ' '
                    flg = TRUE; break
                elsif Pool_[pos+5] = '-'
                    cycle
                else
                    break
                end
            end
            if flg = TRUE
                break
            end
            !if clock()-time1 > 100*100 then break.
        end
    of 'POP3'
        flgmany = 0
        if ~omitted(6)
            flgmany = flgmany_
        end
        i = 0
        loop
            i += 1
            lPool=all('<0>',poolsize)
            ret = mRecv(E_Socket_,lPool,poolsize,loc_);
            if ret<=0 then break.
            if pooltype_
                spoolsize = len(apool)+len(lPool)+1
                spool &= NEW(CSTRING(spoolsize))
                spool = apool & lPool

                apool=all('<0>',apoolsize)
                dispose(apool)

                apoolsize = spoolsize
                apool &= NEW(CSTRING(apoolsize))
                apool = spool

                spool=all('<0>',spoolsize)
                dispose(spool)
            else
                apool = apool & lPool
            end
            if i = 1
                if aPool[1:3] <> '+OK' then flgmany = 0.
            end
            if flgmany = 0 then break.

            l = len(clip(apool))
            if val(apool[l-4]) = 13 and val(apool[l-3]) = 10 and val(apool[l-2]) = 46 and val(apool[l-1]) = 13 and val(apool[l]) = 10
              break
            end
        end

        if pooltype_
          self.pool=all('<0>',poolsize_)
          dispose(self.pool)
          self.pool &= NEW(CSTRING(apoolsize))
          self.pool = apool
        else
          pool_=apool
        end

    end

    apool=all('<0>',apoolsize)
    dispose(apool)

    lPool=all('<0>',poolsize)
    dispose(lPool)
 RETURN ret

!=================================================
EMail.KillSocket        PROCEDURE
 code
    if Self.FlgProgress = 1
        EMail_CloseProgress()
    end
    er#=mCloseSocket(Self.E_Socket)
    er#=mWSACleanUP()
 return

!=================================================
EMail.AddLog          PROCEDURE(string QLine)
l       long
beg     long
pos     long
pos2    long
lLine   string(80)
 code
 if SELF.NoAddLOG then return.
    beg = 1; pos = 0; pos2 = 0
    if instring('<13,10>',QLine,1,1)
        pos2 = -1
        loop
            pos = pos2+2
            pos2 = instring('<13,10>',QLine,1,pos)
            if pos2 = 0 then break.
            Self.NumLog += 1
            Self.QLog.Num = Self.NumLog
            Self.QLog.Line = QLine[pos : pos2-1]
            add(Self.QLog,+Self.QLog.Num)
        end
    else
            Self.NumLog += 1
            Self.QLog.Num = Self.NumLog
            Self.QLog.Line = QLine
            add(Self.QLog,+Self.QLog.Num)
    end
 return

!=================================================
EMail.ListLog          PROCEDURE
EMail_WinLog WINDOW(' LOG'),AT(,,300,200),FONT('MS Sans Serif',8,,),CENTER,SYSTEM,GRAY,AUTO, |
         MODAL
       LIST,AT(0,0,300,200),USE(?List),VSCROLL,ALRT(MouseLeft2),FORMAT('20L(2)|M@S160@#2#'),FROM(Self.QLog)
     END
 code
    open(EMail_WinLog)
    accept
        case field()
        of ?List
            case event()
            of Event:AlertKey
                case keycode()
                of MouseLeft2
                    get(Self.QLog,choice(?List))
                    setclipboard(Self.QLog.Line)
                end
            end
        end
    end
    close(EMail_WinLog)
 return

!=================================================
EMail.InitSocket        PROCEDURE
ERR     long
MailHost        cstring(80)
MailPort        long
!TmpLine   like(Self.QMail.Line)
i   long
flagerror   long
Ndots   long
LogName string(80)
 code
    flagerror = 0; Ndots = 0; i = 0; ERR = 0
    !ERR#=mWSACleanUP()
    clear(EMail_SockAddr_in)
    clear(EMail_WSAData)
    Self.AddLog(' ')
    if mWSAStartup(2,EMail_WSAData) < 0
        ERR = mWSAGetLastError()
        case SELF.ShowErr
        of 1
          SELF.ErrStr = '   ('&ERR&')'
        end
        return ERR
    end
    Self.AddLog(EMail_WSAData.szDescription)
    Self.AddLog('  OK')
    Self.AddLog(' ')
    clear(Self.E_Socket)
    Self.E_Socket=mSocket(2,1,0)
    if Self.E_Socket<0
        ERR=mWSAGetLastError()
        case SELF.ShowErr
        of 1
          SELF.ErrStr = '   ('&ERR&')'
        end
        return ERR
    end
    Self.AddLog('  OK')
    Self.AddLog(' ')
    Self.QSrv.Position=0
    Self.QSrv.SubPosition=0
    get(Self.QSrv,Self.QSrv.Position,Self.QSrv.SubPosition)
    loop i=len(clip(Self.QSrv.Line)) to 1 by -1
        if Self.QSrv.Line[i]=':'
            MailPort=Self.QSrv.Line[i+1:len(clip(Self.QSrv.Line))]
            break
        end
    end
    MailHost=sub(Self.QSrv.Line,1,i-1)

    loop i=1 to len(clip(Self.QSrv.Line))
        if isalpha(Self.QSrv.Line[i]) then flagerror+=1.
        if Self.QSrv.Line[i]='.' then Ndots+=1.
    end

    if flagerror
        GetInetAddr=mGetHostByName(MailHost)
        if GetInetAddr=0
            ERR=5; return ERR
        end
        peek(GetInetAddr+12,GetInetAddr)
        peek(GetInetAddr,GetInetAddr)
        peek(GetInetAddr,GetInetAddr)
        peek(mInet_NToA(GetInetAddr),LogName)      !ip 
        Self.AddLog(LogName)
        EMail_SockAddr_in.sin_addr.s_addr=GetInetAddr
    else
        EMail_SockAddr_in.sin_addr.s_addr=mInet_addr(MailHost)
        if EMail_SockAddr_in.sin_addr.s_addr=4294967295
            ERR=6
            case SELF.ShowErr
            of 1
              SELF.ErrStr = ' mInet_addr(MailHost)'
            end
            Self.AddLog(' mInet_addr(MailHost)')
            return ERR
        end
        GetInetAddr=EMail_SockAddr_in.sin_addr.s_addr
        !message(Self.nFile)
        !GetInetAddr=mGetHostByAddr(address(GetInetAddr),4,Self.nFile) !AF_INET equate(2)
        !message(GetInetAddr)
        if GetInetAddr = 0      !    ip    ,     peek  GPF.
            ERR=5
            case SELF.ShowErr
            of 1
              SELF.ErrStr = ' mGetHostByAddr -  '
            end
            Self.AddLog(' mGetHostByAddr -  ')
            return ERR               !       .  ( )
        end
        !peek(GetInetAddr,GetInetAddr)
        !peek(GetInetAddr,LogName)
        Self.AddLog(LogName)
    end
    Self.AddLog('  OK')
    EMail_SockAddr_in.Sin_Family=2
    EMail_SockAddr_in.Sin_Port=mHtons(MailPort)
 return ERR

!=================================================
EMail.SmtpConnect        PROCEDURE
ERR     long(0)
TmpLine   like(Self.QSrv.Line)
msgID          string(500)
digest         string(500)
ClientReply    string(500)
LenReply        long
LenStr          long
Base64Str &STRING
 code
    ERR = 0
    Self.AddLog('  ')
    if mConnect(Self.E_Socket,EMail_SockAddr_in,len(EMail_SockAddr_in))<0
        ERR=mWSAGetLastError()
        case SELF.ShowErr
        of 1
          SELF.ErrStr = ' connect  ('&ERR&')'
        end
        Self.AddLog('connect = '& ERR)
        return ERR
    end
    if Self.Recv(Self.E_Socket,Pool,PoolSize,0)<0
        ERR=mWSAGetLastError()
        case SELF.ShowErr
        of 1
          SELF.ErrStr = ' recv  ('&ERR&')'
        end
        Self.AddLog('recv = '& ERR)
        return ERR
    end
    Self.AddLog(clip(pool))
    if pool[1:3]<>'220'
        ERR=7
        case SELF.ShowErr
        of 1
          SELF.ErrStr = '   ('&ERR&')'
        end
        return ERR
    end
    Self.AddLog('   OK')

    Self.AddLog('')
    get(Self.QSrv,2)
    Self.AddLog(Self.QMail.Line)
    pool=all('<0>',poolsize)
    pool=clip(Self.QSrv.Line) & '<13,10>'
    if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
        ERR=mWSAGetLastError()
        case SELF.ShowErr
        of 1
          SELF.ErrStr = '   ('&ERR&')'
        end
        return ERR
    end
    if Self.Recv(Self.E_Socket,pool,poolSize,0)<0
        ERR=mWSAGetLastError()
        case SELF.ShowErr
        of 1
          SELF.ErrStr = '   ('&ERR&')'
        end
        return ERR
    end
    Self.AddLog(clip(pool))
    if pool[1:3]<>clip('250')
        ERR=pool[1:3]
        case SELF.ShowErr
        of 1
          SELF.ErrStr = '   ('&ERR&')'
        end
        return ERR
    end
    pool=upper(pool)
    get(Self.QSrv,3)
    Self.QSrv.Line=Email_Base64ToString(Self.QSrv.Line, LenStr)
    if instring('CRAM-MD5',pool,1,1) and Self.QSrv.Line<>''
        pool=all('<0>',poolsize)
        pool='AUTH CRAM-MD5' & '<13,10>'
        if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
            ERR=mWSAGetLastError()
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        pool=all('<0>',poolsize)
        if Self.Recv(Self.E_Socket,pool,poolSize,0)<0
            ERR=mWSAGetLastError()
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        msgID=pool[1:len(clip(pool))-2]
        Self.AddLog(msgID)
        if MSGID[1:3]<>'334'
            ERR=MSGID[1:3]
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        msgID=Email_Base64ToString(msgID[5:len(clip(msgID))], LenStr)
        TmpLine=Self.QSrv.Line
        get(Self.QSrv,4)
        Self.QSrv.Line=Email_Base64ToString(Self.QSrv.Line, LenStr)
        digest=EMail_HMACMD5(clip(msgID),clip(Self.QSrv.Line))
        pool=all('<0>',poolsize)
        ClientReply=clip(TmpLine)&' '&clip(digest)
        LenReply=len(clip(ClientReply))
        Base64Str &= Email_StringToBase64New(ClientReply,LenReply)
        pool=Base64Str & '<13,10>'
        clear(Base64Str)
        dispose(Base64Str)
        if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
            ERR=mWSAGetLastError()
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        pool=all('<0>',poolsize)
        if Self.Recv(Self.E_Socket,pool,poolSize,0)<0
            ERR=mWSAGetLastError()
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        Self.AddLog(clip(pool))
        if pool[1:3]<>'235'
            ERR=pool[1:3]
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
    elsif instring('LOGIN',pool,1,1) and Self.QSrv.Line<>''
        pool=all('<0>',poolsize)
        pool='AUTH LOGIN' & '<13,10>'
        if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
            ERR=mWSAGetLastError()
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        pool=all('<0>',poolsize)
        if Self.Recv(Self.E_Socket,pool,poolSize,0)<0
            ERR=mWSAGetLastError()
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        Self.AddLog(clip(pool))
        if pool[1:3]<>'334'
            ERR=pool[1:3]
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        pool=all('<0>',poolsize)
        Base64Str &= Email_StringToBase64New(clip(Self.QSrv.Line),len(clip(Self.QSrv.Line)))
        pool= Base64Str & '<13,10>'
        clear(Base64Str)
        dispose(Base64Str)
        Self.AddLog(clip(pool))
        if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
            ERR=mWSAGetLastError()
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        pool=all('<0>',poolsize)
        if Self.Recv(Self.E_Socket,pool,poolSize,0)<0
            ERR=mWSAGetLastError()
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        Self.AddLog(clip(pool))
        if pool[1:3]<>'334'
            ERR=pool[1:3]
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        get(Self.QSrv,4)
        pool=all('<0>',poolsize)
        pool= clip(Self.QSrv.Line) & '<13,10>'
        Self.AddLog(all('*',16))
        if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
            ERR=mWSAGetLastError()
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        if Self.Recv(Self.E_Socket,pool,poolSize,0)<0
            ERR=mWSAGetLastError()
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        Self.AddLog(clip(pool))
        if pool[1:3]<>'235'
            ERR=pool[1:3]
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
    elsif instring('PLAIN',pool,1,1) and Self.QSrv.Line<>''
        pool=all('<0>',poolsize)
        pool='AUTH PLAIN' & '<13,10>'
        if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
            ERR=mWSAGetLastError()
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        if Self.Recv(Self.E_Socket,pool,poolSize,0)<0
            ERR=mWSAGetLastError()
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        Self.AddLog(clip(pool))
        if pool[1:3]<>'334'
            ERR=pool[1:3]
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        pool=all('<0>',poolsize)
        pool= clip(Self.QSrv.Line) & '<13,10>'
        Self.AddLog(clip(pool))
        if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
            ERR=mWSAGetLastError()
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        if Self.Recv(Self.E_Socket,pool,poolSize,0)<0
            ERR=mWSAGetLastError()
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        Self.AddLog(clip(pool))
        if pool[1:3]<>'334'
            ERR=pool[1:3]
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        get(Self.QSrv,4)
        Self.QSrv.Line=Email_Base64ToString(Self.QSrv.Line, LenStr)
        pool=all('<0>',poolsize)
        pool= clip(Self.QSrv.Line) & '<13,10>'
        Self.AddLog(clip(pool))
        if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
            ERR=mWSAGetLastError()
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        if Self.Recv(Self.E_Socket,pool,poolSize,0)<0
            ERR=mWSAGetLastError()
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
        Self.AddLog(clip(pool))
        if pool[1:3]<>'235'
            ERR=pool[1:3]
            case SELF.ShowErr
            of 1
              SELF.ErrStr = '   ('&ERR&')'
            end
            return ERR
        end
    else
    end
    Self.AddLog(' OK')
 return ERR

!=================================================
EMail.Pop3Connect        PROCEDURE
ERR     long(0)
TmpLine   like(Self.QSrv.Line)
msgID          string(500)
digest         string(500)
ClientReply    string(500)
LenReply        long
 code
    ERR = 0
    Self.AddLog('  ')
    if mConnect(Self.E_Socket,EMail_SockAddr_in,len(EMail_SockAddr_in))<0
        ERR=mWSAGetLastError()
        Self.AddLog('connect = '& ERR)
        return ERR
    end
    if Self.Recv(Self.E_Socket,Pool,PoolSize,0)<0
        ERR=mWSAGetLastError()
        Self.AddLog('recv = '& ERR)
        return ERR
    end
    Self.AddLog(clip(pool))
    if pool[1:3]<>'+OK'
        SELF.ErrStr = sub(clip(pool),6,len(clip(pool))-5)
        ERR=7; return ERR
    end
    Self.AddLog('   OK')

    Self.AddLog('')
    get(Self.QSrv,2)
    Self.AddLog(Self.QMail.Line)
    pool=all('<0>',poolsize)
    pool='USER '& clip(Self.QSrv.Line) & '<13,10>'
    if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
        ERR=mWSAGetLastError()
        Self.AddLog('send = '& ERR)
        return ERR
    end
    if Self.Recv(Self.E_Socket,pool,poolSize,0)<0
        ERR=mWSAGetLastError()
        Self.AddLog('recv = '& ERR)
        return ERR
    end
    Self.AddLog(clip(pool))
    if pool[1:3]<>clip('+OK')
        SELF.ErrStr = sub(clip(pool),6,len(clip(pool))-5)
        ERR=8; return ERR
    end

    get(Self.QSrv,3)
    Self.AddLog(Self.QMail.Line)
    pool=all('<0>',poolsize)
    pool='PASS '& clip(Self.QSrv.Line) & '<13,10>'
    if mSend(Self.E_Socket,pool,len(clip(pool)),0)<0
        ERR=mWSAGetLastError()
        Self.AddLog('send = '& ERR)
        return ERR
    end
    if Self.Recv(Self.E_Socket,pool,poolSize,0)<0
        ERR=mWSAGetLastError()
        Self.AddLog('recv = '& ERR)
        return ERR
    end
    Self.AddLog(clip(pool))
    if pool[1:3]<>clip('+OK')
        SELF.ErrStr = sub(clip(pool),6,len(clip(pool))-5)
        ERR=8; return ERR
    end
    Self.AddLog(' OK')
    return ERR

!=================================================
Email.SetQMail          PROCEDURE(<string EName>,<string EAddress>,<String MString>,<long npp>)
in_     long
l       long
ll      long
ost     long
i       long
tmpstr  string(80)
tmpstr2  string(80)
Base64Str &STRING
 code
    in_ = 0; l = 0; ll = 0; ost = 0; i = 0; tmpstr = ''

    Self.QMail.Position=npp
    Self.QMail.SubPosition=0
    get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
    in_=0
    if errorcode()
        Self.AddQMail(clip(MString),npp,0,0,'')
        !in_ += 1
    else
        loop
            Self.QMail.Subposition=in_
            get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
            if errorcode()
                in_ -= 1; break
            end
            in_ += 1
        end
    end
    Self.QMail.Position=npp
    Self.QMail.Subposition=in_
    get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
    TmpStr=clip(Self.QMail.Line)
    delete(Self.QMail)
    Self.QMail.Position=npp
    Self.QMail.SubPosition=in_
    Self.QMail.Line=clip(TmpStr)
    Self.QMail.Wait=0
    Self.QMail.What=''
    if clip(Self.QMail.Line)<>clip(Mstring) then Self.QMail.Line=Clip(Self.QMail.Line) & ','.

    l=len(clip(EName))

    if omitted(2) or ~l
        if len(Clip(Self.QMail.Line))+len(Clip(EAddress)) > 74
            tmpstr = Clip(Self.QMail.Line) & '='
            Self.QMail.Line = Clip(tmpstr)
            Self.AddQMail()
            Self.QMail.SubPosition+=1
            if ~omitted(3) then Self.QMail.Line='   <<' & clip(EAddress) &'>'.
        else
            if ~omitted(3) then Self.QMail.Line=Clip(Self.QMail.Line) &' <<'& clip(EAddress) &'>'.
        end
        Self.AddQMail()
        return
    else
        ll=len(clip(Self.QMail.Line))
        if ll+l/3*4+15>74
        !if ll+42>74
            Self.AddQMail()
            Self.QMail.SubPosition+=1
            Self.QMail.Line=''
        end
        tmpstr = clip(Self.QMail.Line)
        ost=l%42
        loop i = 1 to l by 42
            case clip(Self.Encoding)
            of 'QUOTED-PRINTABLE'
                tmpstr = clip(tmpstr) &' =?'& clip(Self.CharSetSend) &'?Q?'& |
                clip(EMail_StringToQuoted(clip(Self.ConvertCharSet(EName[i : (i + choose((i+41)<=l,41,ost-1))],Self.CharSetDef,Self.CharSetSend)), choose((i+41)<=l,42,ost))) & '?='
            else
                tmpstr = clip(tmpstr) &' =?'& clip(Self.CharSetSend) &'?B?'
                Base64Str &= Email_StringToBase64New(clip(Self.ConvertCharSet(EName[i : (i + choose((i+41)<=l,41,ost-1))],Self.CharSetDef,Self.CharSetSend)), choose((i+41)<=l,42,ost))
                tmpstr = clip(tmpstr) & Base64Str & '?='
                clear(Base64Str)
                dispose(Base64Str)
            end
            Self.QMail.Line=clip(tmpstr)
            if i + 42 <= l
                Self.AddQMail()
                Self.QMail.SubPosition+=1
                Self.QMail.Line=''
                tmpstr=''
            end
        end
        if len(Clip(EAddress))
            if len(Clip(Self.QMail.Line))+len(Clip(EAddress))>74
                Self.AddQMail()
                Self.QMail.SubPosition+=1
                Self.QMail.Line = '   <<' & clip(EAddress) &'>'
            else
                Self.QMail.Line = clip(Self.QMail.Line) & ' <<' & clip(EAddress) &'>'
            end
        end
        Self.AddQMail()
    end
 return

!=================================================
EMail.AddQMail         PROCEDURE(<string QLine>,<long QPos>,<long QSPos>,<byte Qwait>,<string Qwhat>)
 code
    if ~omitted(2)
        Self.QMail.Line=QLine
    end
    if ~omitted(3)
        Self.QMail.Position=QPos
    end
    if ~omitted(4)
        Self.QMail.SubPosition=QSpos
    end
    if ~omitted(5)
        Self.QMail.wait=Qwait
    end
    if ~omitted(6)
        Self.QMail.What=QWhat
    end
    add(Self.QMail)
    sort(Self.QMail,+Self.QMail.Position,+Self.QMail.Subposition)
 return

!=================================================
EMail.AddQSrv         PROCEDURE(<string QLine>,<long QPos>,<long QSPos>,<byte Qwait>,<string Qwhat>)
 code
    if ~omitted(2)
        Self.QSrv.Line=QLine
    end
    if ~omitted(3)
        Self.QSrv.Position=QPos
    end
    if ~omitted(4)
        Self.QSrv.SubPosition=QSpos
    end
    if ~omitted(5)
        Self.QSrv.wait=Qwait
    end
    if ~omitted(6)
        Self.QSrv.What=QWhat
    end
    add(Self.QSrv)
    sort(Self.QSrv,+Self.QSrv.Position,+Self.QSrv.Subposition)
 return

!=================================================
EMail.FileToBase64   PROCEDURE(<string InFileName>, <long Npp>)
EMail_InFile         FILE,DRIVER('DOS'),NAME(EMail_PathFile),PRE(EIF)
Record                   RECORD,PRE()
Byte                        Byte,dim(57)
Group                       GROUP,OVER(Byte)
Line                         string(57)
                            END
                         END
                     END
npos long
ERR long
nb  long
Base64Str &STRING
  code
    ERR = 0
    EMail_PathFile=InFileName
    Open(EMail_InFile,0h)
    if errorcode()
        ERR=1; message('  '); return ERR
    end
    set(EMail_InFile)
    npos=6
    loop
        next(EMail_InFile); if errorcode() then break.
        nb = bytes(EMail_InFile)
        Base64Str &= Email_StringToBase64New(EIF:Line[1:nb], nb)
        if Base64Str &= null
          ERR = 2
          break
        end
        Self.AddQMail(Base64Str,npp,npos,0,'')
        clear(Base64Str)
        dispose(Base64Str)
        !Self.AddQMail(clip(Email_StringToBase64(EIF:Line[1:nb],nb)),npp,npos,0,'')
        npos+=1
    end
    close(EMail_InFile)
 return ERR


!=================================================
EMail.Base64ToFile   PROCEDURE(string InFileName, string InPool)
EMail_InFile         FILE,DRIVER('DOS'),CREATE,NAME(EMail_PathFile),PRE(EIF)
Record                   RECORD,PRE()
Byte                        Byte,dim(57)
Group                       GROUP,OVER(Byte)
Line                         string(57)
                            END
                         END
                     END
npos    long
ERR     long
nb      long
l       long
i       long
 code
    ERR = 0
    InPool = Email_Base64ToString(InPool, l)
    !l = len(clip(InPool))
    EMail_PathFile= clip(Self.PathFile) & clip(InFileName)
    remove(EMail_InFile)
    create(EMail_InFile)
    Open(EMail_InFile,12h)
    if errorcode()
        ERR=1; message('  '); return ERR
    end
    loop i = 1 to l by 57
        if l-i > 57
            EIF:Line = InPool[i : i+56]
            add(EMail_InFile); if errorcode() then message(error()); ERR=1; break.
        else
            EIF:Line = clip(InPool[i : l])
            add(EMail_InFile,l-i+1); if errorcode() then message(error()); ERR=1; break.
        end
    end
    close(EMail_InFile)
 return ERR

!=================================================
EMail.ConvertCharSet   PROCEDURE(string Str_In, string CharSet_From, string CharSet_To)
i           long
l           long

strInpChar  &CSTRING
strWideChar &CSTRING
strOutChar  &CSTRING
lenWideChar long
CodeInpChar long
CodeOutChar long
 code
    if clip(upper(CharSet_From)) = clip(upper(CharSet_To)) then return Str_In.
    Self.QCharSet.Name = clip(upper(CharSet_From))
    get(Self.QCharSet, Self.QCharSet.Name)
    if error() then message('    '& clip(upper(CharSet_From)) &' !!!'); return Str_In.
    CodeInpChar = Self.QCharSet.Code

    Self.QCharSet.Name = clip(upper(CharSet_To))
    get(Self.QCharSet, Self.QCharSet.Name)
    if error() then message('    '& clip(upper(CharSet_To)) &' !!!'); return Str_In.
    CodeOutChar = Self.QCharSet.Code

    l = len(clip(str_in))

    strInpChar &= new(CSTRING(l + 1)); strInpChar = all('<0>',l)
    strWideChar &= new(CSTRING(l*2 + 1)); strWideChar = all('<0>',l*2)
    strOutChar &= new(CSTRING(l*2 + 1)); strOutChar = all('<0>',l*2)

    strInpChar = clip(Str_In)

    lenWideChar = MultiByteToWideChar(CodeInpChar,0,strInpChar,l,strWideChar,l)
    res# = WideCharToMultiByte(CodeOutChar,0,strWideChar,lenWideChar,strOutChar,l*2,0,0)

    Str_In = strOutChar
    strInpChar = all('<0>',l); dispose(strInpChar)
    strWideChar = all('<0>',l*2); dispose(strWideChar)
    strOutChar = all('<0>',l*2); dispose(strOutChar)

 return Str_In

!=================================================
EMail.FileToQuoted   PROCEDURE(<string InFileName>, <long npp>)
TmpFileString          String(3072)
EMail_InFile         FILE,DRIVER('DOS'),NAME(EMail_PathFile),PRE(EIF)
Record                   RECORD,PRE()
Byte                        Byte,dim(1024)
Group                       GROUP,OVER(Byte)
Line                         string(1024)
                            END
                         END
                     END
ERR long
i   long
ls  long
is  long
LocLine     like(Self.QMail.Line)
 code
    ERR = 0; LocLine = ''
    EMail_PathFile = InFileName
    open(EMail_InFile,0h)
    if errorcode()
        ERR = 1; message('  '); return ERR
    end
    set(Email_InFile)
    next(Email_Infile)
    loop i=1 to 10
        if inrange(EIF:Byte[i],1,31)
            ERR = 1; message(' ASCII !|    Quoted Printable!'); break
        end
    end
    close(EMail_InFile)
    if ERR<>0 then return ERR.
    open(EMail_InFile,0h)
    set(EMail_InFile)
    Self.QMail.Wait=0
    Self.QMail.What=''
    Self.QMail.Position=npp
    Self.QMail.SubPosition=6
    loop
        next(EMail_InFile); if errorcode() then break.
        clear(Self.QMail.Line)
        ls=bytes(EMail_InFile)
        TmpFileString=Email_StringToQuoted(EIF:Line[1:ls],ls)
        ls=len(clip(TmpFileString))
        is=0
        loop i=1 to ls
            is+=1
            LocLine = clip(Self.QMail.Line) & TmpFileString[i]
            Self.QMail.Line=clip(LocLine)
            if is>70
                if Self.QMail.Line[is-1]='=' or Self.QMail.Line[is]='='
                    cycle
                else
                    LocLine = clip(Self.QMail.Line) & '='
                    Self.QMail.Line= clip(LocLine)
                    is=0
                    Self.QMail.SubPosition+=1
                    Self.AddQMail()
                    clear(Self.QMail.Line)
                end
            end
        end
        Self.AddQMail()
    end
    Close(EMail_InFile)
 return ERR

EMail.QuotedToFile   PROCEDURE(string InFileName, string InPool)
EMail_InFile         FILE,DRIVER('DOS'),CREATE,NAME(EMail_PathFile),PRE(EIF)
Record                   RECORD,PRE()
Byte                        Byte,dim(1024)
Group                       GROUP,OVER(Byte)
Line                         string(1024)
                            END
                         END
                     END
npos    long
ERR     long
nb      long
l       long
i       long
 code
    ERR = 0
    l = len(clip(InPool))
    InPool = Email_QuotedToString(InPool,l)
    l = len(clip(InPool))
    EMail_PathFile= clip(Self.PathFile) & clip(InFileName)
    remove(EMail_InFile)
    create(EMail_InFile)
    Open(EMail_InFile,12h)
    if errorcode()
        ERR=1; message('  '); return ERR
    end
    loop i = 1 to l by 1024
        if l-i > 1024
            EIF:Line = InPool[i : i+1023]
            add(EMail_InFile); if errorcode() then ERR=1; break.
        else
            EIF:Line = clip(InPool[i : l])
            add(EMail_InFile,l-i+1); if errorcode() then ERR=1; break.
        end
    end
    close(EMail_InFile)
 return ERR

EMail.Bit8ToFile   PROCEDURE(string InFileName, string InPool)
EMail_InFile         FILE,DRIVER('DOS'),CREATE,NAME(EMail_PathFile),PRE(EIF)
Record                   RECORD,PRE()
Byte                        Byte,dim(1024)
Group                       GROUP,OVER(Byte)
Line                         string(1024)
                            END
                         END
                     END
npos    long
ERR     long
nb      long
l       long
i       long
 code
    ERR = 0
    l = len(clip(InPool))

    !InPool = Email_QuotedToString(InPool,l)
    !l = len(clip(InPool))

    EMail_PathFile= clip(Self.PathFile) & clip(InFileName)
    remove(EMail_InFile)
    create(EMail_InFile)
    Open(EMail_InFile,12h)
    if errorcode()
        ERR=1; message('  '); return ERR
    end
    loop i = 1 to l by 1024
        if l-i > 1024
            EIF:Line = InPool[i : i+1023]
            add(EMail_InFile); if errorcode() then ERR=1; break.
        else
            EIF:Line = clip(InPool[i : l])
            add(EMail_InFile,l-i+1); if errorcode() then ERR=1; break.
        end
    end
    close(EMail_InFile)
 return ERR

!=================================================
EMail.FindString       PROCEDURE(string Vid_In, *? Str_InOut)
l           long
i           long
rzd         string(1)
rzd2        string(1)
flg         long
pos         long
pos2        long
pos3        long
lpool       cstring(PoolSize)
 code
    Str_InOut = ''
    l = len(clip(Self.pool))
    lpool=all('<0>',poolsize)
    pos = instring(clip(upper(Vid_In)),upper(Self.pool),1,1)
    if ~pos then return.
    pos += len(clip(Vid_In))
    flg = FALSE
    rzd2 = ''
    loop
        pos2 = instring('<13,10>',upper(Self.pool),1,pos)
        if pos2
            rzd = rzd2; rzd2 = ''
            loop i = (pos2+2) to l
                case val(Self.pool[i])
                of 9 ; cycle  !!Tab
                of 32; cycle  !!' '
                of 60; rzd2 = '*'; break  !!<
                of 62; break  !!>
                of 61; break  !!=
                else ; flg = TRUE; break
                end
            end
            if rzd
                lpool = clip(lpool) &' '& clip(left(Self.pool[pos : pos2-1]))
            else
                lpool = clip(lpool) & clip(left(Self.pool[pos : pos2-1]))
            end
            if flg = TRUE
                break
            end
            pos=i
        else
            break
        end
    end
    Self.DecodeString(lpool)
    Str_InOut = clip(left(lpool))
 return

EMail.DecodeString       PROCEDURE(*? Str_InOut)
l           long
pos         long
pos2        long
pos3        long
pos4        long
lCharSet    string(30)
lpool       &cstring
LenStr      long
 code

    l = len(clip(Str_InOut))+1
    lpool &= new(cstring(l)); lpool = all('<0>',l)
    lpool = Str_InOut
    pos = 0; pos2 = 0; pos3 = 0
    loop
        pos = instring('=?',lpool,1,1)
        if pos
            pos4 = instring(',',lpool,1,pos)
            if ~pos4 then pos4=len(clip(lpool)).
            pos2 = instring('?B?',lpool[pos : pos4],1,1)+pos-1
            if pos2-pos+1
                lCharSet = lpool[pos+2 : pos2-1]
                pos3 = instring('?=',lpool,1,pos2+3)
                if pos3 and pos3>pos2+3
                    lpool = lpool[1 : pos-1] &|
                    clip(Self.ConvertCharSet(Email_Base64ToString(lpool[pos2+3 : pos3-1], LenStr),lCharSet,Self.CharSetDef)) &|
                    lpool[pos3+2 : len(clip(lpool))]
                else
                    lpool = lpool[1 : pos-1]
                    break
                end
            else
                pos2 = instring('?Q?',lpool[pos : pos4],1,1)+pos-1
                if pos2-pos+1
                    lCharSet = lpool[pos+2 : pos2-1]
                    pos3 = instring('?=',lpool,1,pos2+3)
                    if pos3
                        lpool = lpool[1 : pos-1] &|
                        clip(Self.ConvertCharSet(Email_QuotedToString(lpool[pos2+3 : pos3-1],len(clip(lpool[pos2+3 : pos3-1]))),lCharSet,Self.CharSetDef)) &|
                        lpool[pos3+2 : len(clip(lpool))]
                    else
                        lpool = lpool[1 : pos-1]
                        break
                    end
                else
                    break
                end
            end
        else
            break
        end
    end
    Str_InOut = clip(left(lpool))
    lpool = all('<0>',l)
    dispose(lpool)
 return

!=================================================
EMail.FindText      PROCEDURE(string Bound_In, *? Str_InOut, *long Num_InOut, *byte Flg_File, *string ContType)
pos         long
pos2        long
pos3        long
pos31       long
pos4        long
pos5        long
pos6        long
pos61       long
pos7        long
lCharSet    string(30)
lContType   string(50)
lPartType   string(30)
!lFileName       string(250)
lEncod      string(100)
lFile       string(250)
i           long
temp        string(500)
lpool       &cstring
l           long
lBound      string(100)
LenStr      long
 code
    lCharSet = ''; lEncod = '8bit'; lFile = ''; Flg_File = 0; lBound=Bound_In
    l = len(clip(self.pool))
    lpool &= new(cstring(l)); lpool = all('<0>',l)
    lpool = self.pool
metka
    if len(clip(lBound))
        pos = instring(clip(upper(lBound)),upper(lpool),1,Num_InOut)
        pos7 = instring(upper('<13,10>CONTENT-TYPE:'),upper(lpool),1,pos)
    else
        pos = 1
        pos7 = instring(upper('<13,10>CONTENT-TYPE:'),upper(lpool),1,Num_InOut)
    end
    if ~pos7 then lpool = all('<0>',l); dispose(lpool); return 'ERR'.

    pos3 = instring(';',upper(lpool),1,pos7)
    lContType = lpool[pos7+16 : pos3-1]
metka2
    pos5 = instring('=',upper(lpool),1,pos3)
    pos6 = instring('<13,10>',upper(lpool),1,pos5)
    pos61 = instring(';',upper(lpool),1,pos5)
    if pos61>0 and pos61<pos6 then pos6=pos61.
    lPartType = upper(lpool[pos3+1 : pos5-1])
    loop i#=1 to len(clip(lPartType))
      case val(lPartType[i#])
      of 9 orof 10 orof 13
        lPartType[i#]=' '
      end
    end

    lPartType = clip(left(lPartType))
    !----
    case clip(left(lPartType))
    of 'CHARSET'
        if lpool[pos5+1] = '"'
            lCharSet = lpool[pos5 + 2 : pos6-2]
        else
            lCharSet = lpool[pos5 + 1 : pos6-1]
        end
    of 'NAME'
        if lpool[pos5+1] = '"'
            lFile = lpool[pos5 + 2 : pos6-2]
        else
            lFile = lpool[pos5 + 1 : pos6-1]
        end
    of 'FORMAT'
        pos3 = pos6+1
        pos5 = instring('=',upper(lpool),1,pos3)
        pos6 = instring('<13,10>',upper(lpool),1,pos5)
        if lpool[pos6-1]=';' then pos6 = pos6-1.
        lPartType = upper(lpool[pos3+1 : pos5-1])
        loop i#=1 to len(clip(lPartType))
          case val(lPartType[i#])
          of 9 orof 10 orof 13
            lPartType[i#]=' '
          end
        end
        lPartType = clip(left(lPartType))
        if clip(lPartType)='CHARSET'
          if lpool[pos5+1] = '"'
              lCharSet = lpool[pos5 + 2 : pos6-2]
          else
              lCharSet = lpool[pos5 + 1 : pos6-1]
          end
        end
    of 'BOUNDARY'
      pos6 = instring('<13,10>',upper(lpool),1,pos5)
      if lpool[pos6-1]=';' then pos6-=1.
      if lpool[pos5+1] = '"'
        lBound = '<13,10>--'& lpool[pos5 + 2 : pos6-2]
      else
        lBound = '<13,10>--'& lpool[pos5 + 1 : pos6-1]
      end
      if instring(clip(upper(lBound)),upper(lpool),1,pos6)
        goto metka
      else
        lBound=Bound_In
        pos3=pos6
        goto metka2
      end
    else
!        message('       !')
        lpool = all('<0>',l); dispose(lpool); return 'ERR'
    end
    ContType=clip(left(lContType))
    pos3 = pos
    pos4 = instring('<13,10>CONTENT-TRANSFER-ENCODING:',upper(lpool),1,pos)
    if pos4
        pos = instring('<13,10>',upper(lpool),1,pos4+2)
        lEncod = lpool[pos4 + 29 : pos-1]
    else
        pos4 = instring('CONTENT-',upper(lpool),1,pos)
        if pos4
            pos = instring('<13,10>',upper(lpool),1,pos4)
        else
            lpool = all('<0>',l); dispose(lpool); return 'ERR'
        end
    end
    pos = instring('<13,10,13,10>',upper(lpool),1,pos-1)
    if pos
        pos += 4
        if lBound
            pos2 = instring(clip(upper(lBound)),upper(lpool),1,pos)
        else
            !pos2 = instring('<13,10>.',upper(lpool),1,pos)
            pos2 = instring('<13,10,46,13>',upper(lpool),1,pos)
            if ~pos2 then pos2=len(lpool).
        end
        pos5# = instring('CONTENT-DISPOSITION: ATTACHMENT',upper(lpool),1,pos3)
        if ~pos5#
          pos5 = instring('CONTENT-DISPOSITION: INLINE',upper(lpool),1,pos3)
        else
          pos5=pos5#
        end
        if pos5
            if pos5 < pos2
                pos3# = instring('FILENAME=',upper(lpool),1,pos5)
                if ~pos3#
                  pos3=instring('NAME=',upper(lpool),1,pos3)
                  pos31=pos3+5
                else
                  pos3=pos3#
                  pos31=pos3+9
                end
                if pos3
                  loop
                    pos32#=val(lpool[pos31])
                    case pos32#
                      of 9 orof 13 orof 10 orof 32
                        pos31+=1
                    else
                      break
                    end
                  end
                  if lpool[pos31]='"'
                    pos4 = instring('"',upper(lpool),1,pos31+1)+1
                  else
                    pos4 = instring('<13><10>',upper(lpool),1,pos31+1)+1
                    pos3 = pos3-1
                  end
                  if pos3 < pos2
                      lFile = lpool[pos31 + 1 : pos4-2]
                      Self.DecodeString(lFile)
                      i#=0
                      loop
                        i#+=1
                        if i#>len(clip(lFile)) then break.
                        pos6=val(lFile[i#])
                        case pos6
                        of 9 orof 13 orof 10
                          if i#=len(clip(lfile))
                            lFile=lFile[1 : i#-1]
                            break
                          else
                            lFile=lFile[1 : i#-1]&lFile[i#+1 : len(clip(lfile))]
                            i#-=1
                          end
                        end
                      end
                      if lfile[1]='"' and lfile[len(clip(lfile))]='"' then lfile=lfile[2:len(clip(lfile))-1].
                      if ~lFile then lpool = all('<0>',l); dispose(lpool); return 'ERR'.
                  else
                      if ~lCharSet then lpool = all('<0>',l); dispose(lpool); return 'ERR'.
                  end
                else
                  if ~lCharSet then lpool = all('<0>',l); dispose(lpool); return 'ERR'.
                end
            else
                if ~lCharSet then lpool = all('<0>',l); dispose(lpool); return 'ERR'.
            end
        else
            if instring('IMAGE/',upper(lContType),1,1)
                pos4 = instring('<13,10,13,10>',upper(lpool),1,pos3)
                Self.DecodeString(lFile)
            else
                if ~lCharSet then lpool = all('<0>',l); dispose(lpool); return 'ERR'.
            end
        end
        if ~lEncod then lpool = all('<0>',l); dispose(lpool); return 'ERR'.
        Num_InOut = pos2
        if pos2
            if lFile
                lpool = lpool[pos : pos2-1]
                case clip(upper(lEncod))
                of 'QUOTED-PRINTABLE'
                    err# = Self.QuotedToFile(lFile, lpool)
                    if err#
                        lpool = '    '& clip(lFile)
                    else
                        !lpool = clip(Self.PathFile) & clip(lFile)
                        lpool = clip(lFile)
                    end
                of 'BASE64'
                    err# = Self.Base64ToFile(lFile, lpool)
                    if err#
                        lpool = '    '& clip(lFile)
                    else
                        !lpool = clip(Self.PathFile) & clip(lFile)
                        lpool = clip(lFile)
                    end
                else
                    err# = Self.Bit8ToFile(lFile, lpool)
                    if err#
                        lpool = '    '& clip(lFile)
                    else
                        !lpool = clip(Self.PathFile) & clip(lFile)
                        lpool = clip(lFile)
                    end
                end
                Flg_File = 1
            else
                case clip(upper(lEncod))
                of 'QUOTED-PRINTABLE'
                    lpool = clip(Self.ConvertCharSet(EMail_QuotedToString(lpool[pos : pos2-1],len(clip(lpool[pos : pos2-1]))),lCharSet,Self.CharSetDef))
                of 'BASE64'
                    lpool = clip(Self.ConvertCharSet(EMail_Base64ToString(lpool[pos : pos2-1], LenStr),lCharSet,Self.CharSetDef))
                else
                    lpool = clip(Self.ConvertCharSet(lpool[pos : pos2-1],lCharSet,Self.CharSetDef))
                end
            end
        end
    else
        lpool = all('<0>',l); dispose(lpool); return 'ERR'
    end

    Str_InOut = clip(left(lpool))
    lpool = all('<0>',l); dispose(lpool)

 return ''

!=================================================
EMail.SetQMailDate      PROCEDURE
GMT             string(5)
th              long
gmt_            long
d   string(3)
m   string(3)
 code
    execute today()%7
        d='Mon'
        d='Tue'
        d='Wed'
        d='Thu'
        d='Fri'
        d='Sat'
        d='Sun'
    end
    execute month(today())
        m='Jan'
        m='Feb'
        m='Mar'
        m='Apr'
        m='May'
        m='Jun'
        m='Jul'
        m='Aug'
        m='Sep'
        m='Oct'
        m='Nov'
        m='Dec'
    end
    Self.QMail.Position=5
    Self.QMail.SubPosition=0
    get(Self.QMail,Self.QMail.Position,Self.QMail.SubPosition)
    GetSystemTime(SystemTime)
    th=sub(format(clock(),@T1),1,2)
    if SystemTime.WDAY<>day(today())
        th+=24
    end
    gmt_=th-SystemTime.WHOUR
    if gmt_>12
        gmt_=-(24-gmt_)
    end
    if gmt_>0
        gmt=format(gmt_,@p+##00p)
    else
        gmt=format(gmt_,@p-##00p)
    end
    Self.QMail.Line='DATE: ' & clip(d) & ', '&format(day(today()),@n02)&' '& clip(m) &' '&format(year(today()),@p####p)&' ' & format(clock(),@t4) & ' '&gmt
    put(Self.QMail)
 return

